#include <SPI.h>
#include <Wire.h>
#include <Adafruit_SSD1306.h>

#define VRX A1
#define VRY A0
#define SW 8

Adafruit_SSD1306 display(0);

void setup() {
  Serial.begin(9600);

  pinMode(VRX, INPUT);
  pinMode(VRY, INPUT);
  pinMode(SW, INPUT_PULLUP);

  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);//definiujemy rodzaj użytego wyświetlacza oraz adres I2C
  display.clearDisplay();//czyścimy ekran
  display.setTextColor(WHITE);//ustawiamy kolor biały
}

bool wybor = 0;//odpowiada za wybor menu wilgotnosci lub temperatury
bool zatwierdz_w = 0;//odpowiada za wybieranie opcji w menu wilgotnosci
bool zatwierdz_t = 0;//odpowiada za wybieranie opcji w menu temp
bool zatwierdzony_w = 0;//odpowiada za zatwierdzenie opcji wilgotnosci i przejscie do niej
bool zatwierdzony_t = 0;//odpowiada za zatwierdzenie opcji temperatury i przejscie do niej
int wilgotnosc = 20;
int temperatura = 26;

void loop() {
  if (analogRead(VRY) > 500) {
    wybor = false;
  } else if (analogRead(VRY) < 100) {
    wybor = true;
  }

  switch (wybor) {
    case 0:

      if (analogRead(VRX) > 650  && zatwierdzony_w == false) {
        zatwierdz_w = true;
      } else if (analogRead(VRX) < 10  && zatwierdzony_w == false) {
        zatwierdz_w = false;
      }

      switch (zatwierdz_w) {
        case 0:
          display.clearDisplay();//czyścimy ekran
          display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
          display.setTextSize(2);// ustawiamy rozmiar czcionki
          display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
          display.println("WILGOTNOSC");//piszemy tekst który ma się ukazać

          display.setTextSize(1);// ustawiamy rozmiar czcionki
          display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
          display.println("*AKTUALNA WILGOTNOSC");
          display.setCursor(4, 30);//ustawiamy kursor na daną pozycję
          display.println("USTAW WILGOTNOSC");//piszemy tekst który ma się ukazać

          if (digitalRead(SW) == LOW && zatwierdzony_w == true) {
            zatwierdzony_w = false;
          } else if (digitalRead(SW) == LOW) {
            zatwierdzony_w = true;
          }

          if (zatwierdzony_w == true) {
            display.clearDisplay();//czyścimy ekran
            display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
            display.setTextSize(1);// ustawiamy rozmiar czcionki
            display.println("AKTUALNA WILGOTNOSC");//piszemy tekst który ma się ukazać
            display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
            display.setTextSize(3);// ustawiamy rozmiar czcionki
            display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
            display.print("20");//piszemy tekst który ma się ukazać
            display.print("%");
          }

          display.display();//wyświetlamy na ekranie, bez tego nie zadziała
          break;
        case 1:
          display.clearDisplay();//czyścimy ekran
          display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
          display.setTextSize(2);// ustawiamy rozmiar czcionki
          display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
          display.println("WILGOTNOSC");//piszemy tekst który ma się ukazać

          display.setTextSize(1);// ustawiamy rozmiar czcionki
          display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
          display.println("AKTUALNA WILGOTNOSC");
          display.setCursor(4, 30);//ustawiamy kursor na daną pozycję
          display.println("*USTAW WILGOTNOSC");//piszemy tekst który ma się ukazać

          if (digitalRead(SW) == LOW && zatwierdzony_w == true) {
            zatwierdzony_w = false;
          } else if (digitalRead(SW) == LOW) {
            zatwierdzony_w = true;
          }

          if (zatwierdzony_w == true) {
            display.clearDisplay();//czyścimy ekran
            display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
            display.setTextSize(1);// ustawiamy rozmiar czcionki
            display.println("USTAW WILGOTNOSC");//piszemy tekst który ma się ukazać
            display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
            display.setTextSize(3);// ustawiamy rozmiar czcionki
            display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
            display.print(wilgotnosc);//piszemy tekst który ma się ukazać
            display.print("%");


            while (analogRead(VRX) > 400) {
              wilgotnosc -= 2;

              display.clearDisplay();//czyścimy ekran
              display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
              display.setTextSize(1);// ustawiamy rozmiar czcionki
              display.println("USTAW WILGOTNOSC");//piszemy tekst który ma się ukazać
              display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
              display.setTextSize(3);// ustawiamy rozmiar czcionki
              display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
              if (wilgotnosc < 0) {
                wilgotnosc = 0;
              }
              display.print(wilgotnosc);//piszemy tekst który ma się ukazać
              display.print("%");
              display.display();
            }
            while (analogRead(VRX) < 200) {
              wilgotnosc += 2;

              display.clearDisplay();//czyścimy ekran
              display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
              display.setTextSize(1);// ustawiamy rozmiar czcionki
              display.println("USTAW WILGOTNOSC");//piszemy tekst który ma się ukazać
              display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
              display.setTextSize(3);// ustawiamy rozmiar czcionki
              display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
              if (wilgotnosc > 100) {
                wilgotnosc = 100;
              }
              display.print(wilgotnosc);//piszemy tekst który ma się ukazać
              display.print("%");
              display.display();
            }
          }
          display.display();//wyświetlamy na ekranie, bez tego nie zadziała
          break;
      }
      break;
    case 1:
      if (analogRead(VRX) > 650  && zatwierdzony_t == false) {
        zatwierdz_t = true;
      } else if (analogRead(VRX) < 10  && zatwierdzony_t == false) {
        zatwierdz_t = false;
      }
      
      switch (zatwierdz_t) {
        case 0:
          display.clearDisplay();//czyścimy ekran
          display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
          display.setTextSize(2);// ustawiamy rozmiar czcionki
          display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
          display.println("TEMP.");//piszemy tekst który ma się ukazać

          display.setTextSize(1);// ustawiamy rozmiar czcionki
          display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
          display.println("*AKTUALNA TEMP.");
          display.setCursor(4, 30);//ustawiamy kursor na daną pozycję
          display.println("USTAW TEMP.");//piszemy tekst który ma się ukazać

          if (digitalRead(SW) == LOW && zatwierdzony_t == true) {
            zatwierdzony_t = false;
          } else if (digitalRead(SW) == LOW) {
            zatwierdzony_t = true;
          }

          if (zatwierdzony_t == true) {
            display.clearDisplay();//czyścimy ekran
            display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
            display.setTextSize(1);// ustawiamy rozmiar czcionki
            display.println("AKTUALNA TEMP.");//piszemy tekst który ma się ukazać
            display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
            display.setTextSize(3);// ustawiamy rozmiar czcionki
            display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
            display.print("20");//piszemy tekst który ma się ukazać
            display.print("*C");
          }

          display.display();//wyświetlamy na ekranie, bez tego nie zadziała
          break;
        case 1:
          display.clearDisplay();//czyścimy ekran
          display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
          display.setTextSize(2);// ustawiamy rozmiar czcionki
          display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
          display.println("TEMP.");//piszemy tekst który ma się ukazać

          display.setTextSize(1);// ustawiamy rozmiar czcionki
          display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
          display.println("AKTUALNA TEMP.");
          display.setCursor(4, 30);//ustawiamy kursor na daną pozycję
          display.println("*USTAW TEMP.");//piszemy tekst który ma się ukazać

          if (digitalRead(SW) == LOW && zatwierdzony_t == true) {
            zatwierdzony_t = false;
          } else if (digitalRead(SW) == LOW) {
            zatwierdzony_t = true;
          }

          if (zatwierdzony_t == true) {
            display.clearDisplay();//czyścimy ekran
            display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
            display.setTextSize(1);// ustawiamy rozmiar czcionki
            display.println("USTAW TEMP.");//piszemy tekst który ma się ukazać
            display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
            display.setTextSize(3);// ustawiamy rozmiar czcionki
            display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
            display.print(temperatura);//piszemy tekst który ma się ukazać
            display.print("*C");

            while (analogRead(VRX) > 400) {
              temperatura -= 2;

              display.clearDisplay();//czyścimy ekran
              display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
              display.setTextSize(1);// ustawiamy rozmiar czcionki
              display.println("USTAW TEMP.");//piszemy tekst który ma się ukazać
              display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
              display.setTextSize(3);// ustawiamy rozmiar czcionki
              display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
              if (temperatura < 0) {
                temperatura = 0;
              }
              display.print(temperatura);//piszemy tekst który ma się ukazać
              display.print("*C");
              display.display();
            }
            while (analogRead(VRX) < 200) {
              temperatura += 2;

              display.clearDisplay();//czyścimy ekran
              display.setCursor(4, 0);//ustawiamy kursor na daną pozycję
              display.setTextSize(1);// ustawiamy rozmiar czcionki
              display.println("USTAW TEMP.");//piszemy tekst który ma się ukazać
              display.writeFastHLine(0, 16, 128, WHITE);//rysujemy białą linię, dwa pierwsze parametry odpowiadają za szerokość i wysokość, pozostałe dwa za szerokość lini oraz kolor
              display.setTextSize(3);// ustawiamy rozmiar czcionki
              display.setCursor(4, 20);//ustawiamy kursor na daną pozycję
              if (temperatura > 36) {
                temperatura = 36;
              }
              display.print(temperatura);//piszemy tekst który ma się ukazać
              display.print("*C");
              display.display();
            }
          }

          display.display();//wyświetlamy na ekranie, bez tego nie zadziała
          break;
      }
  }
}
